# AUTOGENERATED! DO NOT EDIT! File to edit: ../nbs/03_LinearRegression.ipynb.

# %% auto 0
__all__ = ['path', 'df', 'new_df', 'price', 'reg', 'numbers_list', 'data', 'area_df', 'p']

# %% ../nbs/03_LinearRegression.ipynb 2
import pandas as pd
import numpy as np
import matplotlib.pyplot as plt
from pathlib import Path

# %% ../nbs/03_LinearRegression.ipynb 3
path = Path('Data/homeprices.csv')
df = pd.read_csv(path)
df

# %% ../nbs/03_LinearRegression.ipynb 4
plt.xlabel('area')
plt.ylabel('price')
plt.scatter(df.area,df.price,color='red',marker='+')

plt.show()

# %% ../nbs/03_LinearRegression.ipynb 5
new_df = df.drop('price',axis='columns')
new_df

# %% ../nbs/03_LinearRegression.ipynb 6
price = df.price
price

# %% ../nbs/03_LinearRegression.ipynb 7
from sklearn import linear_model

# %% ../nbs/03_LinearRegression.ipynb 8
# Create linear regression object
reg = linear_model.LinearRegression()
reg.fit(new_df,price)

# %% ../nbs/03_LinearRegression.ipynb 9
reg.predict([[3300]])

# %% ../nbs/03_LinearRegression.ipynb 10
reg.coef_

# %% ../nbs/03_LinearRegression.ipynb 11
reg.intercept_

# %% ../nbs/03_LinearRegression.ipynb 13
5000*reg.coef_ + reg.intercept_

# %% ../nbs/03_LinearRegression.ipynb 14
reg.predict([[5000]])

# %% ../nbs/03_LinearRegression.ipynb 17
numbers_list = list(range(2000, 4000, 500))

# %% ../nbs/03_LinearRegression.ipynb 18
# Create a DataFrame using the pandas constructor and a dictionary
data = {'area': numbers_list}
area_df = pd.DataFrame(data)
area_df

# %% ../nbs/03_LinearRegression.ipynb 19
p = reg.predict(area_df)
p

# %% ../nbs/03_LinearRegression.ipynb 20
area_df['prices']=p
area_df

# %% ../nbs/03_LinearRegression.ipynb 21
plt.xlabel('area')
plt.ylabel('price')
plt.scatter(df.area,
            df.price,
            color='red',
            marker='+')

plt.scatter(area_df.area,
            area_df.prices,
            color='green',
            marker='o')

plt.show()

# %% ../nbs/03_LinearRegression.ipynb 22
area_df.to_csv("./Data/prediction.csv")
